#include "AminoAcid.h"

//ALA,RES_TMP0,CYS,ASP,GLU,PHE,GLY,HIS,ILE,RES_TMP1,LYS,LEU,MET,ASN,RES_TMP2,PRO,GLN,ARG,SER,THR,RES_TMP3,VAL,TRP,RES_TMP4,TYR
const RESIDUE_INDEX AminoAcid::m_indexes[25]={ALA,(RESIDUE_INDEX)-1,CYS,ASP,GLU,PHE,GLY,HIS,ILE,(RESIDUE_INDEX)-1,LYS,LEU,MET,ASN,(RESIDUE_INDEX)-1,PRO,GLN,ARG,SER,THR,(RESIDUE_INDEX)-1,VAL,TRP,(RESIDUE_INDEX)-1,TYR};


//ARG,LYS,GLU,GLN,ASP,ASN,PRO,GLY,SER,THR,HIS,ALA,ILE,LEU,VAL,PHE,CYS,MET,TYR,TRP
const float AminoAcid::m_fFreqOfOccurrence[20]={0.047,
                                        0.07,
                                        0.062,
                                        0.039,
                                        0.055,
                                        0.044,
                                        0.046,
                                        0.075,
                                        0.071,
                                        0.06,
                                        0.021,
                                        0.09,
                                        0.046,
                                        0.075,
                                        0.069,
                                        0.035,
                                        0.028,
                                        0.017,
                                        0.035,
                                        0.011};

float AminoAcid::getFreqOfOccurrence(RESIDUE_INDEX index){
  return m_fFreqOfOccurrence[index];
}

RESIDUE_INDEX AminoAcid::getResidueTypeIndx(const char cRes){
  RESIDUE_INDEX indx=m_indexes[(int)cRes-(int)'A'];

  if((int)indx<0 || (int)indx>24){
    cerr<<"SequenceScore: unknown residue type:"<<cRes<<endl;
    return (RESIDUE_INDEX) -1;
  }else
    return indx;
}


