#ifndef __COMPONENTNODE_H
#define __COMPONENTNODE_H

/*
CLASS
  ComponentNode

  A template class that was written for the use of the ConnectedComponents 
  class in order to wrap the basic elements in a link list under the Compnent
  class objects. An attempt was make to conceal this class form the outside 
  user as much as possible.

  For typical usage see ConnectedComponents class documentation.

KEYWORDS
  ConnectedComponents, Component, link list, set

AUTHORS
  Ram Nathaniel <ramn@math.tau.ac.il>

  Copyright: SAMBA group, Tel-Aviv Univ. Israel, 1998.

GOALS
  Create a wrapper for elements to be used in a link list data structure.
  Used in the Component class.

USAGE
  
  */

template<class elementT> class ComponentNode{
public:
  ComponentNode(elementT* elem){element=elem; next=NULL;}
  
  elementT* element;
  ComponentNode *next;
  
  friend ostream& operator<<(ostream& s, const ComponentNode& n){
    s << *(n.element);
    return s;
  }
};

#endif


