#ifndef __DFS_GRAPH_NODE_H
#define __DFS_GRAPH_NODE_H

#include <vector.h>
#include "GraphNode.h"

/*
CLASS
  DFSGraphNode

  A template class that was written for the use of the BConnectedComponents 
  class in order to wrap the basic elements and create a graph structure from 
  the elements as well as a link list under the BCompnent class objects. 
  In opposed to the base class ComponentNode this class should be public and
  open to the user for it is a good infrasturcture to implement graphs
  algorithms.

  For usage example see BConnectedComponents::DFS.

KEYWORDS
  BConnectedComponents, BComponent, link list, set, graph

AUTHORS
  Ram Nathaniel <ramn@math.tau.ac.il>

  Copyright: SAMBA group, Tel-Aviv Univ. Israel, 1998.

GOALS
  Create a wrapper for elements to be used as vertices of a graph as well as 
  in a link list data structure. 
USAGE
  
  */


template<class elementT> 
class DFSGraphNode:public GraphNode<class elementT>{
public:
  int dfs_time;
  int low;
  int dfs_end;

  GraphNode<elementT> *dfs_parent;  
  
  DFSGraphNode(elementT *elem, int index):GraphNode(elem, index){
    dfs_time=-1;
    low=-1;
    dfs_end=-1;
    dfs_parent=NULL;
  }
};

#endif

