/*
LIBRARY
  GAMB

  The library is written as a toolbox for the SAMBA group at TAU. The library
  implements some basic algebraic classes and functions in 3D space, defines
  base classes and templates for reading and storing PDB file objects such
  as atoms, and finally implements a good intuitively interfaced geometric hash
  table template.

AUTHORS
  Meir Fuchs (meirfux@math.tau.ac.il).
  Zipi Fligelman (zipo@math.tau.ac.il).

  Copyright: SAMBA group, Tel-Aviv Univ. Israel, 1997.

CHANGES LOG
<UL>
<LI>
</UL

CODE
  Code is written in close accordance to the Ellemtel C++ 
  rules_and_recommendations. These can be found at 
  mol/lib/Documentation/cpprules.html

  The code is documented using specially formatted comments. Using a freeware
  package named cocoon a javadoc like html documentation was generated from the
  source code and may be found in the Documentation directory of the library.
  The cocoon package resides at mol/utils/cocoon.

  The cocoon_utilities can be found at 
  http://www.cs.umn.edu/~kotula/cocoon/cocoon.htm. One can get intructions
  on what kind of comments coccon expects to find and what it will do with
  them.

COMPILATION
  The code is compiled using a Makefile to create a code library named
  libgamb++.a. The library may be used by other makefiles of when compiling
  projects by using the gcc -I, -L and -l flags. (See gcc man pages). 

  Currently code is compiled using the SGI STL library which was ported to GNU.
  This STL implementation is considered the best and may be found at
  /mol/lib/gstl with a Documentation directory.
  */  
