#include "HelixPDB.h"
#include "string.h"
#include <stdlib.h>
#include "ctype.h"
#include "iostream.h"

typedef HelixPDB::HelixType HelixType;
// general notice make sure about the numbers with the conters 
// regarding pointers and pointer arithmatics.

bool HelixPDB::isHelix(const char* const PDBrec)
{
  return (strncmp(PDBrec, "HELIX", 5) == 0);
}

short HelixPDB::helixID(const char * const PDBrec)
{
  return atoi(PDBrec+serNumField);
}
   
void HelixPDB::initResName(const char* const PDBrec, char *res)
{
  strncpy(res,PDBrec+initResNameField, 3);
  res[3]='\0';
}

char HelixPDB::initChainID(const char* const PDBrec)
{
  return (PDBrec[initChainIdField]);
}


int HelixPDB::initSeqNum(const char* const PDBrec)
{
  return (atoi(PDBrec+initSeqNumField));
}


char HelixPDB::initICode(const char* const PDBrec)
{
  return PDBrec[initICodeField];
}


void HelixPDB::endResName(const char* const PDBrec, char *res)
{
  strncpy(res,PDBrec+endResNameField, 3);
  res[3]='\0';
}

char HelixPDB::endChainID(const char* const PDBrec)
{
  return (PDBrec[endChainIdField]);
}


int HelixPDB::endSeqNum(const char* const PDBrec)
{
  return (atoi(PDBrec+endSeqNumField));
}


char HelixPDB::endICode(const char* const PDBrec)
{
  return PDBrec[endICodeField];
}


HelixType HelixPDB::helixClass(const char* const PDBrec)
{
  if (isspace(PDBrec[ helixClassField]) 
      && isspace(PDBrec[helixClassField+1]))
    return Unknown;
  else
    return (HelixType)(atoi(PDBrec+helixClassField));
}

unsigned short HelixPDB::length(const char* const PDBrec)
{
  return atoi(PDBrec+lengthField);
}

  
