#include "HashIndex.h"

HashIndex::HashIndex() : size(0), used(0), values(NULL)
{}

HashIndex::HashIndex(unsigned short indexSize) 
  : size(indexSize), used(0)
{
  values = new float[size];
}

HashIndex::~HashIndex()
{
  delete[] values;
}

void HashIndex::add(float value)
{
  if (used < size) {
    values[used] = value;
    ++used;
  }
}
  
void HashIndex::add(const Vector3& v)
{
  add(v[0]);
  add(v[1]);
  add(v[2]);
}

HashIndex& HashIndex::operator<<(float value)
{
  add(value);
  return *this;
}

HashIndex& HashIndex::operator<<(const Vector3& v)
{
  add(v);
  return *this;
}

void HashIndex::reset()
{
  used = 0;
}

float& HashIndex::operator[](unsigned short index) const
{
  return values[index%size];
}

ostream& operator<<(ostream& out, HashIndex& hi)
{
  for (int i=0; i<hi.used; ++i)
    out << hi.values[i] << ' ';
  return out;
}

