#include "Sheet.h"
#include "StrandPDB.h"
#include <string>

#define MaxStrandsInSheet 20

Sheet::Sheet()
    : BetaSheet(MaxStrandsInSheet)
{
  for(int i=0; i < 3 ; ++i)
    snum[i]=(char)0;
}

Sheet::Sheet(const unsigned short size, const char sheet_id[])
  : BetaSheet(size)
{
  strncpy(snum,sheet_id,3);
}

Sheet::Sheet(const char* const PDBrec)
  : BetaSheet(StrandPDB::numOfStrandsInSheet(PDBrec))
    
{
  StrandPDB::strandSheetId(PDBrec,snum);
  push_back(Strand(PDBrec));
}
 
Sheet::Sheet(const Sheet& sh)
    : BetaSheet(sh)
{}

bool Sheet::isCurrSheet(const char sheetId[])
{
  // cna make it stright will be more efficient
  return (strncmp(snum,sheetId,3) == 0);
}
bool Sheet::add(const char* const PDBrec)
{
  char tmp[3];
  StrandPDB::strandSheetId(PDBrec,tmp);
  if (!full() && (strncmp(snum,tmp,3)==0)) {
    push_back(Strand(PDBrec));
    return true;
  }
  else
    return false;
}

ostream& operator<<(ostream& s, const Sheet   & bs)
{
  s << "SHEET " << bs.snum[0] << bs.snum[1] << bs.snum[2] << endl;
  for (Sheet::const_iterator it = bs.begin() ; 
       it != bs.end() ; ++it)
    s << *it << endl;
  return s;
}


