#include <stdlib.h>
#include "Shou.h"

bool Shou::isRec(const char* const shouRec)
{
  return (atoi(shouRec) != 0);
}

unsigned short Shou::atomIndex(const char *const shouRec, 
			       unsigned int atom) 
{
	unsigned short fieldLength=5;
	char num[fieldLength];
	for(int i=0; i<fieldLength; i++)
		num[i] = shouRec[5*atom+i];
	num[fieldLength]='\0';
	return atoi(num);
}

float Shou::xCoord(const char* const shouRec)
{
	unsigned short fieldLength=yCoordField-xCoordField;
	char num[fieldLength+1];
	for(int i=0; i<fieldLength; i++)
		num[i] = shouRec[xCoordField+i];
	num[fieldLength]='\0';
  return atof(num);
}

float Shou::yCoord(const char* const shouRec)
{
	unsigned short fieldLength=zCoordField-yCoordField;
	char num[fieldLength+1];
	for(int i=0; i<fieldLength; i++)
		num[i] = shouRec[yCoordField+i];
	num[fieldLength]='\0';
  return atof(num);	
}

float Shou::zCoord(const char* const shouRec)
{
	unsigned short fieldLength=surfaceField-zCoordField;
	char num[fieldLength+1];
	for(int i=0; i<fieldLength; i++)
		num[i] = shouRec[zCoordField+i];
	num[fieldLength]='\0';
  return atof(num);	
}

float Shou::surface(const char* const shouRec)
{
	unsigned short fieldLength=xNormField-surfaceField;
	char num[fieldLength+1];
	for(int i=0; i<fieldLength; i++)
		num[i] = shouRec[surfaceField+i];
	num[fieldLength]='\0';
  return atof(num);
}

float Shou::xNorm(const char* const shouRec)
{
	unsigned short fieldLength=yNormField-xNormField;
	char num[fieldLength+1];
	for(int i=0; i<fieldLength; i++)
		num[i] = shouRec[xNormField+i];
	num[fieldLength]='\0';
  return atof(num);
}

float Shou::yNorm(const char* const shouRec)
{
	unsigned short fieldLength=zNormField-yNormField;
	char num[fieldLength+1];
	for(int i=0; i<fieldLength; i++)
		num[i] = shouRec[yNormField+i];
	num[fieldLength]='\0';
  return atof(num);
}

float Shou::zNorm(const char* const shouRec)
{
	unsigned short fieldLength=zNormField-yNormField;
	char num[fieldLength+1];
	for(int i=0; i<fieldLength; i++)
		num[i] = shouRec[zNormField+i];
	num[fieldLength]='\0';
  return atof(num);
}

