/* $Id: macros.h,v 1.1 1997/06/02 16:21:17 meirfux Exp $ */

#ifndef _macros_h
#define _macros_h

//// Template function returns x squared.
template<class T>
inline T sqr(const T x)
{
  return x*x;
}

//// Template function returns absolute value of referenced x.
template<class T>
inline T tabs(const T& x) {
  return (x < 0) ? -x : x;
}

//// Template function returns a with b's sign
template<class T, class S>
inline T sign(const T a, const S b)
{
  return ((b) >= 0.0 ? tabs(a) : -tabs(a));
}

//// Template function returns minimum of two numbers
template<class T>
inline T min(const T x, const T y){
  return ((x < y)? x : y);
}

////Template function returns maximum of two numbers
template<class T>
inline T max(const T x, const T y){
  return ((x > y)? x : y);
}

////Template function returning maximum of three numbers
template<class T>
inline T max3(const T x, const T y, const T z){
  if ( x > y )
    return ((x > z) ? x : z);
  else
    return ((y > z) ? y : z);
}
 
//// Template function returnin minimun of three numbers
template<class T>
inline T min3(const T x, const T y, const T z)
{
  if (x < y)
    return ((x < z) ? x : z);
  else
    return ((y < z) ? y : z);
}

//// sorting x y and z from smalles to biggest such that x<=y<=z
template<class T>
inline void sort3(T& x, T& y, T& z)
{
    T tmp;
    if (x > y) {
        tmp = x;
        x = y;
        y = tmp;
    }
    else if (x > z) {
        tmp = x;
        x = z;
        z = tmp;
    }
    else if (y > z) {
        tmp = y;
        y = z;
        z = tmp;
    }
}
    
#endif

