

#pragma warning( disable : 4305 )

#include "list.h"
#include "hash_map.h"
#include "iostream.h"

#include "fstream.h"


#include "Molecule.h"
#include "Atom.h"
#include "PDB.h"

using namespace std;

typedef list<int> MyIntList;



struct eqstr
{
  bool operator()(const char* s1, const char* s2) const
  {
    return strcmp(s1, s2) == 0;
  }
};

/*


int main()
{
  hash_map<const char*, int, hash<const char*>, eqstr> months;
  
  months["january"] = 31;
  months["february"] = 28;
  months["march"] = 31;
  months["april"] = 30;
  months["may"] = 31;
  months["june"] = 30;
  months["july"] = 31;
  months["august"] = 31;
  months["september"] = 30;
  months["october"] = 31;
  months["november"] = 30;
  months["december"] = 31;
  
  cout << "september -> " << months["september"] << endl;
  cout << "april     -> " << months["april"] << endl;
  cout << "june      -> " << months["june"] << endl;
  cout << "november  -> " << months["november"] << endl;
}
*/

class CAlphaSelector : public PDB::Selector
   {  // This class defines a selector that will pick only C-alpha atoms.
    public:
      bool operator()(const char *PDBrec) const 
	  {
        const char *type = PDB::atomType(PDBrec);
        return (*(type+1) == 'C' && *(type+2) == 'A');
      }
    };


int main(void)
{
	
  hash_map<const char*, int, hash<const char*>, eqstr> months;
  
  months["january"] = 31;
  months["february"] = 28;
  months["march"] = 31;
  months["april"] = 30;
  months["may"] = 31;
  months["june"] = 30;
  months["july"] = 31;
  months["august"] = 31;
  months["september"] = 30;
  months["october"] = 31;
  months["november"] = 30;
  months["december"] = 31;

  cout << "september -> " << months["september"] << endl;
  cout << "april     -> " << months["april"] << endl;
  cout << "june      -> " << months["june"] << endl;
  cout << "november  -> " << months["november"] << endl;



  Molecule<Atom> molModel,molTarget;
  
  ifstream fileModel("aaa.bbb",ios::in);
  ifstream fileTarget("aaa2.bbb",ios::in);      
  
  /*
  if(!fileModel){
    cout<<"File "<<argv[1]<< "does not exist."<<endl;
    exit(0);
  }
  if(!fileTarget){
    cout<<"File "<<argv[2]<< "does not exist."<<endl;
    exit(0);
  }
*/
  
  molModel.readPDBfile(fileModel, CAlphaSelector());
  molTarget.readPDBfile(fileTarget, CAlphaSelector());


  return 1;



}