// triangle.cpp: implementation of the triangle class.
//
//////////////////////////////////////////////////////////////////////

#include "triangle.h"
#include "Matrix3.h"
#include "math.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

triangle::triangle()
{

}

triangle::triangle(Vector3& a, Vector3& b, Vector3& c)
{
	this->m_A = a;
	this->m_B = b;
	this->m_C = c;
}

// Copy constructor
triangle::triangle(const triangle& tr)
{
	this->m_A = tr.m_A;
	this->m_B = tr.m_B;
	this->m_C = tr.m_C;
}

// Destructor
triangle::~triangle()
{

}

// Assignment operator
triangle& triangle::operator =(const triangle& tr)
{
	this->m_A = tr.m_A;
	this->m_B = tr.m_B;
	this->m_C = tr.m_C;

	return(*this);
}


// Calculate the Baricenter of triangle
Vector3& triangle::Baricenter()
{
	Vector3 *v = new Vector3();

	*v = (this->m_A + this->m_B + this->m_C)*((double)1/(double)3);

	return(*v);
}

// Shift the Baricenter (+)
triangle& triangle::operator +(const Vector3& vec)
{
	triangle *tr = new triangle();

	tr->m_A = this->m_A + vec;
	tr->m_B = this->m_B + vec;
	tr->m_C = this->m_C + vec;

	return(*tr);
}

// Calculate rotation transformation to fit 
// this triangle with triangle tr
RigidTrans3& triangle::operator |(triangle& tr)
{	

    Vector3 shift = this->Baricenter() - tr.Baricenter();

	triangle tr_to_fit = tr + shift;
	// Calculate the Coordinates relatively to this triangle
	Vector3 X = this->m_B - this->m_A;
	Vector3 Z = X & (this->m_C - this->m_A);
	Vector3 Y = X & Z;

	// Calculate the Coordinated relatively to triangle tr_to_fit
	Vector3 Xtr = tr_to_fit.m_B - tr_to_fit.m_A;
	Vector3 Ztr = Xtr & (tr_to_fit.m_C - tr_to_fit.m_A);
	Vector3 Ytr = Xtr & Ztr;

	// Now we should fill in the vectors of matrix
	// with cosines of angles between each axis
	Vector3 v1(cos(X^Xtr), cos(Y^Xtr), cos(Z^Xtr));
	Vector3 v2(cos(X^Ytr), cos(Y^Ytr), cos(Z^Ytr));
	Vector3 v3(cos(X^Ztr), cos(Y^Ztr), cos(Z^Ztr));

	Matrix3 mat(v1, v2, v3);

	RigidTrans3 *rt3 = new RigidTrans3(mat, shift);
	
	return(*rt3);
}